#!/bin/bash
# apt install fonts-dejavu-extra (pour la police de caractères utilisé par le script)

if [ $# -ne 6 ]
   then
	    echo "Usage:"
	    echo "    --audio (ou -a) \"fichier audio au format wav\""
	    echo "    --srt (ou -s) \"fichier sous-titres\""
    	    echo "    --texte (ou -t) \"fichier avec le texte\""
	    echo "    --help"
	    echo ""
            echo "Le script générera la vidéo aux formats webm et mp4"
	    exit 1
fi

while [[ $# > 0 ]]
do
    case "$1" in

	-a|--audio)
	    bandeannonceaudio="$2"
	    shift
	    ;;

	-s|--srt)
	    soustitres="$2"
	    shift
	    ;;

	-t|--texte)
	    textebandeannonce="$2"
	    shift
	    ;;

	--help|*)
	    echo "Usage:"
	    echo "    --audio \"fichier audio\""
	    echo "    --srt \"fichier sous-titres\""
    	    echo "    --texte \"fichier avec le texte\""
	    echo "    --help"
	    exit 1
	    ;;
    esac
    shift
done

bandeannoncevideomp4=`basename $bandeannonceaudio .wav`.mp4
bandeannoncevideowebm=`basename $bandeannonceaudio .wav`.webm

fichiertempvideo1="$(command mktemp -t "tmp.XXXXXXXXXX.mp4")"

fichiertempvideo2="$(command mktemp -t "tmp.XXXXXXXXXX.mp4")"

fichiertempvideo3="$(command mktemp -t "tmp.XXXXXXXXXX.mp4")"

fichiertempvideo4="$(command mktemp -t "tmp.XXXXXXXXXX.mp4")"

fichiertemptextebandeannonce="$(command mktemp -t "tmp.XXXXXXXXXX.txt")"

# Pour contourner le bug ${fichiertemptextebandeannonce}
# Suppression du newline dans le fichier qui servira de texte de la bande annonce
tr -d '\n' < ${textebandeannonce} > ${fichiertemptextebandeannonce}

# Si ce fichier est dans /tmp cela ne fonctionne pas
fichiertemplistefichiers=liste.txt

ffmpeg -y -i ${bandeannonceaudio} -loop 1 -i banniere-libre-a-vous-1024-484.png -filter_complex "[0:a]showwaves=s=1024x484:mode=line:scale=lin:colors=0xeb6013,colorkey=0x000000:0.01:0.1,format=yuva420p[v];[1:v][v]overlay=0:05[outv]" -map "[outv]" -pix_fmt yuv420p -map 0:a -c:v libx264 -c:a aac -shortest ${fichiertempvideo1}

# Avec juste ANSSI : fontsize=45 x=230
#ffmpeg -y -i ${fichiertempvideo1} -vf drawtext="fontfile=/usr/share/fonts/truetype/dejavu/DejaVuMathTeXGyre.ttf: text=${texteannoncecourt}: fontcolor=white: fontsize=25: box=1: boxcolor=0x095083: boxborderw=10: x=30: y=345: enable='between(t,0,1)'" ${fichiertempvideo2}
ffmpeg -y -i ${fichiertempvideo1} -vf drawtext="fontfile=/usr/share/fonts/truetype/dejavu/DejaVuMathTeXGyre.ttf: fontcolor=white: fontsize=22: box=1: boxcolor=0x095083: boxborderw=10: x=10: y=365: textfile=${fichiertemptextebandeannonce}" ${fichiertempvideo2}

# Avec text=L\\\\\'Agence nationale de la sÃ©curitÃ© des systÃ¨mes d\\\\\'information (ANSSI) x=x=1024-80*t et fontsize=45

ffmpeg -y -i ${fichiertempvideo2} -filter_complex "subtitles=${soustitres}:force_style='OutlineColour=&H00000000,Alignment=2,BorderStyle=3,Outline=1,Shadow=0,Fontsize=18'" ${fichiertempvideo3}

# Le fichier licences.mp4 a été généré par la commande 
# ffmpeg -y -loop 1 -i licences-sans-la-musique.png -pix_fmt yuv420p -t 2 licences.mp4

# Le fichier actions.mp4 a été généré par la commande 
# ffmpeg -y -loop 1 -i actions.png -pix_fmt yuv420p -t 2 actions.mp4

# Le fichier lettre-actus-lav.mp4 a été généré par la commande 
# ffmpeg -y -loop 1 -i lettre-actus-lav.png -pix_fmt yuv420p -t 2 lettre-actus-lav.mp4

echo "file ${fichiertempvideo3}" > ${fichiertemplistefichiers}
echo "file actions.mp4" >> ${fichiertemplistefichiers}
echo "file lettre-actus-lav.mp4" >> ${fichiertemplistefichiers}
echo "file licences.mp4" >> ${fichiertemplistefichiers}

ffmpeg -y -f concat -safe 0 -i ${fichiertemplistefichiers} -c copy ${fichiertempvideo4}

ffmpeg -y -i ${fichiertempvideo4} -acodec copy -vcodec copy -metadata title="Bande annonce pour podcast « Libre à vous ! »" -metadata artist="April" -metadata copyright="April- Diffusée selon les termes d’au moins une des licences suivantes : licence Art libre version 1.3 ou ultérieure http://artlibre.org/licence/lal/, licence Creative Commons By Sa version 2.0 ou ultérieure http://creativecommons.org/licenses/by-sa/2.0/fr/ et licence GNU FDL version 1.3 ou ultérieure http://www.gnu.org/licenses/fdl-1.3.html Pour vérifier voir https://www.libreavous.org" -metadata genre="Podcast" -metadata contact="https://libreavous.org" -metadata description="Diffusée selon les termes d’au moins une des licences suivantes : licence Art libre version 1.3 ou ultérieure http://artlibre.org/licence/lal/, licence Creative Commons By Sa version 2.0 ou ultérieure http://creativecommons.org/licenses/by-sa/2.0/fr/ et licence GNU FDL version 1.3 ou ultérieure http://www.gnu.org/licenses/fdl-1.3.html Pour vérifier voir https://www.libreavous.org La musique est un extrait de Wesh tone de Realaze https://play.dogmazic.net/song.php?action=show_song&song_id=758 disponible sous Licence Art Libre http://artlibre.org/licence/lal/" ${bandeannoncevideomp4}

ffmpeg -y -i ${bandeannoncevideomp4} -vcodec libvpx-vp9 -acodec libvorbis ${bandeannoncevideowebm}

rm -f ${fichiertempvideo1}
rm -f ${fichiertempvideo2}
rm -f ${fichiertempvideo3}
rm -f ${fichiertempvideo4}
rm -f ${fichiertemplistefichiers}
